'Morseuhr
' gibt alle 15 min. die Minutenzahl aus und zur vollen Stunde die Stundenzahl
' ("es ist X Uhr")

' Einstellen der Uhrzeit geht nur zur vollen Stunde (Zeitsignal im Radio oder
' TV) per Reset
' Die Startzeit kann per 4-bit "Museklavier" auf 8.00 Uhr bis 23.00 vorge-
' whlt werden.

' Der Tongeber (Buzzer) liegt an PB1, das Museklavier an PB2 ... PB5

' Der Mega8 luft in einem speziellen Uhrenbetrieb. Er wird mit 1 MHz getaktet
' (interner RC- Oszillator), Der Quarzoszillator ist mit einem 32768Hz-Uhren-
' quarz beschaltet, der den Timer 2 asynchron taktet. Timer 2 lst jede
' Sekunde einen Interrupt aus.

' Nach 900 Interrupts ist eine Viertelstunde um.

' Die Konfiguration des Timer2- Uhrenmodus und Erzeugung des Sekundenimpulses
' ist dem "AVR Mikrocontroller-Lehrbuch" von Roland Walter entnommen
'
' Version 4b: Feintuning Sekundentakt eingebaut (beim Tageswechsel Wartezeit oder Preset 
' der Sekundenvariable auf Werte > 0 ) 
'----------------------------------------------------------
$regfile = "m8def.dat"                                      'ATmega8-Deklarationen
$crystal = 1000000                                          'Der AVR-Takt kommt vom RC-Oszillator
$baud = 9600

On Timer2 Ontimer2                                          'Interrupt-Routine fr Timer2-Overflow


'Variablen

Dim S As Word                                               ' Sekunden
Dim Q As Byte                                               ' aufsummierte Viertelstunden
Dim V As Byte                                               ' Viertelstunden fr Morseausgabe
Dim H As Byte                                               ' Stunden
Dim Z As Byte                                               ' Zehnerstelle Stunden
Dim E As Byte                                               ' Einerstelle Stunden

Dim J As Byte
Dim I As Byte                                               ' wird in Zhlschleife verwendet
Dim N As Word                                               ' Aktueller Morsebuchstabe
Dim M As Byte                                               ' wird frs Auslesen der Morsebits verwendet
Dim L As Byte                                               ' niederwertigstes Bit von M verwendet





' Konstanten
Const Dit = 60                                              ' Lnge eines Punkts, daraus ergibt sich die Morsegeschwindigkeit
Const Dah = Dit * 3                                         ' Lnge eines Strichs
Const Wort = Dit * 8                                        ' Lnge der Pause zwischen Wrtern
Const Tonhoehe = 30                                         '20                                       ' Tonhhe

'- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
' Variablen dimensionieren:





Acsr.7 = 1                                                  ' Analogen Komparator ausschalten
Assr.3 = 1                                                  ' Timer2- Asynchron- Betrieb
Tccr2 = &B00000101                                          ' Vorteiler fr Timer2 auf 128 setzen
Timsk.6 = 1                                                 ' Timer2-Overflow-Interrupt an
Mcucr = &B00110000                                          ' Powerssave-Modus aktivieren
Sreg.7 = 1                                                  ' Interrupts global einschalten
Ddrb = &B0000_0000                                          ' alle Pins sind Eingnge
Portb = &B1111_1111                                         ' Pullups, damit die Eingnge nicht floaten
Ddrc = &B0000_0000                                          ' alle Pins sind Eingnge
Portc = &B1111_1111                                         ' Pullups, damit die Eingnge nicht floaten
Ddrd = &B0000_0000                                          ' alle Pins sind Eingnge
Portd = &B1111_1111                                         ' Pullups, damit die Eingnge nicht floaten

'----------------------------------------------------------




' Tonsignal an OC2 / Port B 3 erzeugen; Signal wird unten durch Umschalten des DDRB im Takt der Zeichen geschaltet
'
Config Timer1 = Timer , Compare A = Toggle , Prescale = 64 , Clear Timer = 1
Ocr1a = Tonhoehe
'
Buzzer Alias Ddrb.1


'                                                            ' Startzeit aus den Dip- Schaltern auslesen

Q = Not Pinb                                                ' invertieren, weil gesetzte Dipschalter 0 statt 1 ergeben
Q = Q And &B0011_1100                                       ' die Schalterbits filtern     - >  Q = 0,4,8 .... 28
Q = Q + 32                                                  ' Q = 32,56 .... 80   ->  Startzeit 8,9,10 ....,22,23 Uhr

Goto Einsprung:






Do                                                          'Hauptschleife


'    If S > 14 Then                                          ' Testbetrieb ; 15 sec statt 15 min
   If S > 899 Then                                          ' Realbetrieb
       S = 0
       Q = Q + 1

       If Q = 96 Then                                       ' Tageswechsel; Uhr auf 00 stellen
'       Waitms 500                                           ' Feinabgleich- Beispiel, falls die Uhr etwas zu schnell luft 
         Q = 0
         S = 2                                               ' Feinabgleich, falls die Uhr etwas zu langsam luft 
'        Wait 1
       End If

Einsprung:

       H = Q / 4
       V = Q Mod 4
       Z = H / 10
       E = H Mod 10


' auszugebende Morsezeichen:



         If V = 1 Then                                      ' 15. Minute
            N = 1
            Gosub Morse
            N = 5
            Gosub Morse
         End If

         If V = 2 Then                                      ' 30. Minute
            N = 3
            Gosub Morse
            N = 0
            Gosub Morse
         End If

         If V > 2 Then                                      ' 45. Minute
            N = 4
            Gosub Morse
            N = 5
            Gosub Morse
         End If

         If V = 0 Then                                      ' volle Stunde
            For N = 10 To 16                                ' String "es ist "
               Gosub Morse
            Next
            If Z > 0 Then
              N = Z
              Gosub Morse
            End If
            N = E
            Gosub Morse
            For N = 16 To 19                                ' string " uhr"
            Gosub Morse
            Next
         End If

   End If

     Mcucr.7 = 1                                            'Sleep-Modus erlauben
    !Sleep                                                  'In den Sleep-Modus gehen

Loop





 ' Morsezeichenerzeugung:

   Morse:

     M = Lookup(n , Tdata)

     If M = 0 Then                                          ' Sonderfall: Leerzeichen;
        Waitms Wort
     Goto Sign_end
     End If

     For I = 1 To 8
       If M = 1 Then                                        ' Das Byte hat nur noch den Wert 1; Zeichenende!
          Goto Sign_end
       End If
        L = M And &B0000001                                 ' niederwertigstes Bit lesen
         Buzzer = 1                                         ' Ausgnge einschalten
       If L = 1 Then
          Waitms Dah                                        ' ist das Bit 1 -> dah
         Else
          Waitms Dit                                        ' ist das Bit 0 -> dit
       End If
         Buzzer = 0                                         ' Ausgnge abschalten
       Waitms Dit                                           ' Pause innerhalb des Morsezeichens
       Shift M , Right , 1                                  ' Bits um eine Stelle nach rechts shiften
     Next I
     Sign_end:
     Waitms Dah                                             ' Pause zwischen Morsezeichen
   Return

End


'----------------------------------------------------------
Ontimer2:                                                   'Timer2-Overflow-Interrupt-Routine

  S = S + 1
  Return








'- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
' Codierung der Morsezeichen. Bei einem Prozessor mit viel SRAM wrde man alle Zeichen
' in ein Array einlesen (bersetzungstabelle), den eigentlichen Bakentext in einen String packen
' und diesen String zeichenenweise abarbeiten.
'
' Da der Attiny13 nur ca. 64 Byte SRAM hat, ist nur Platz fr etwa 50 Bytes. Daher ist der Weg hier
' anders:  Der Bakentext ist ein Array mit max. 52 Elementen, in dem die auszusendenden Zeichen stehen
' allerdings in einer leicht lesbaren schreibweise.
' Die bersetzungstabelle ist mit Konstanten realisiert. Nur die wirklich bentigten
' Zeichen werden (beim kompilieren des Programmes) umgewandelt.


Const #a = &B00000110
Const #b = &B00010001
Const #c = &B00010101
Const #d = &B00001001
Const #e = &B00000010
Const #f = &B00010100
Const #g = &B00001011
Const #h = &B00010000
Const #i = &B00000100
Const #j = &B00011110
Const #k = &B00001101
Const #l = &B00010010
Const #m = &B00000111
Const #n = &B00000101
Const #o = &B00001111
Const #p = &B00010110
Const #q = &B00011011
Const #r = &B00001010
Const #s = &B00001000
Const #t = &B00000011
Const #u = &B00001100
Const #v = &B00011000
Const #w = &B00001110
Const #x = &B00011001
Const #y = &B00011101
Const #z = &B00010011
Const #ae = &B00011010
Const #oe = &B00010111
Const #ue = &B00011100
Const #0 = &B00111111
Const #1 = &B00111110
Const #2 = &B00111100
Const #3 = &B00111000
Const #4 = &B00110000
Const #5 = &B00100000
Const #6 = &B00100001
Const #7 = &B00100011
Const #8 = &B00100111
Const #9 = &B00101111

Const Leerz = 0
Const Anfuehrz = &B01010010
Const Kl_auf = &B00101101
Const Kl_zu = &B01101101
Const Plus = &B00101010
Const Komma = &B01110011
Const Minus = &B01100001
Const Punkt = &B01101010
Const Slash = &B00101001
Const Dopp_pkt = &B01000111
Const Gleich = &B00110001
Const Fragez = &B01001100
Const Ende = 255



Tdata:
Data #0 , #1 , #2 , #3 , #4 , #5 , #6 , #7 , #8 , #9
Data #e , #s , Leerz , #i , #s , #t , Leerz , #u , #h , #r
